Index: /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90
===================================================================
--- /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 3582)
+++ /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 3583)
@@ -306,429 +317,144 @@
       ENDIF
          
-      ! Note tide phase speeds are in deg/hour, so we need to convert the
-      ! elapsed time in seconds to hours by dividing by 3600.0
       IF( PRESENT(jit) ) THEN  
-         z_arg = ( (kt-1) * rdt + (jit+time_add) * rdt / REAL(nn_baro,wp) ) * rad / 3600.0
+         z_arg = ( ((kt-kt_tide)-1) * rdt + (jit+time_add) * rdt / REAL(nn_baro,wp) )
       ELSE                              
-         z_arg = (kt+time_add) * rdt * rad / 3600.0
+         z_arg = ((kt-kt_tide)+time_add) * rdt
       ENDIF
 
-      DO itide = 1, td%ncpt
-         z_sarg = z_arg * td%speed(itide)
+      ! Linear ramp on tidal component at open boundaries 
+      zramp = 1.
+      IF (ln_tide_ramp) zramp = MIN(MAX( (z_arg + (kt_tide-nit000)*rdt)/(rdttideramp*rday),0.),1.)
+
+      DO itide = 1, nb_harmo
+         z_sarg = z_arg * omega_tide(itide)
          z_cost(itide) = COS( z_sarg )
          z_sist(itide) = SIN( z_sarg )
       END DO
 
-      DO itide = 1, td%ncpt
-         igrd=1                              ! SSH on tracer grid.
-         DO ib = 1, idx%nblenrim(igrd)
-            dta%ssh(ib) = dta%ssh(ib) + td%ssh(ib,itide,1)*z_cost(itide) + td%ssh(ib,itide,2)*z_sist(itide)
-            !    if(lwp) write(numout,*) 'z', ib, itide, dta%ssh(ib), td%ssh(ib,itide,1),td%ssh(ib,itide,2)
+      DO itide = 1, nb_harmo
+         igrd=1                              ! SSH on tracer grid
+         DO ib = 1, ilen0(igrd)
+            dta%ssh(ib) = dta%ssh(ib) + zramp*(td%ssh(ib,itide,1)*z_cost(itide) + td%ssh(ib,itide,2)*z_sist(itide))
          END DO
          igrd=2                              ! U grid
-         DO ib=1, idx%nblenrim(igrd)
-            dta%u2d(ib) = dta%u2d(ib) + td%u(ib,itide,1)*z_cost(itide) + td%u(ib,itide,2)*z_sist(itide)
-            !    if(lwp) write(numout,*) 'u',ib,itide,utide(ib), td%u(ib,itide,1),td%u(ib,itide,2)
+         DO ib = 1, ilen0(igrd)
+            dta%u2d(ib) = dta%u2d(ib) + zramp*(td%u  (ib,itide,1)*z_cost(itide) + td%u  (ib,itide,2)*z_sist(itide))
          END DO
          igrd=3                              ! V grid
-         DO ib=1, idx%nblenrim(igrd)
-            dta%v2d(ib) = dta%v2d(ib) + td%v(ib,itide,1)*z_cost(itide) + td%v(ib,itide,2)*z_sist(itide)
-            !    if(lwp) write(numout,*) 'v',ib,itide,vtide(ib), td%v(ib,itide,1),td%v(ib,itide,2)
+         DO ib = 1, ilen0(igrd) 
+            dta%v2d(ib) = dta%v2d(ib) + zramp*(td%v  (ib,itide,1)*z_cost(itide) + td%v  (ib,itide,2)*z_sist(itide))
          END DO
       END DO
       !
-      IF( nn_timing == 1 ) CALL timing_stop('tide_update')
+      IF( nn_timing == 1 ) CALL timing_stop('bdytide_update')
       !
-   END SUBROUTINE tide_update
-
-!!gm  doctor naming of dummy argument variables!!!   and all local variables
-
-   SUBROUTINE uvset( ihs, iday, imnth, iyr, f, z_vplu )
-      !!----------------------------------------------------------------------
-      !!                   ***  SUBROUTINE uvset  ***
-      !!                     
-      !! ** Purpose : - adjust tidal forcing for date factors
-      !!                
-      !!----------------------------------------------------------------------
-      implicit none
-      INTEGER, INTENT( in ) ::   ihs     ! Start time hours
-      INTEGER, INTENT( in ) ::   iday    ! start time days
-      INTEGER, INTENT( in ) ::   imnth   ! start time month
-      INTEGER, INTENT( in ) ::   iyr     ! start time year
-      !!
-!!gm  nc is jptides_max ????
-      INTEGER , PARAMETER     ::  nc =15    ! maximum number of constituents
-      CHARACTER(len=8), DIMENSION(nc) :: cname
-      INTEGER                 ::   year, vd, ivdy, ndc, i, k
-      REAL(wp)                ::   ss, h, p, en, p1, rtd
-      REAL(wp), DIMENSION(nc) ::   f                          ! nodal correction
-      REAL(wp), DIMENSION(nc) ::   z_vplu                     ! phase correction
-      REAL(wp), DIMENSION(nc) ::   u, v, zig
-      !!
-      DATA cname/  'q1'    ,    'o1'    ,     'p1'   ,    's1'    ,     'k1'    ,   &
-         &         '2n2'   ,    'mu2'   ,     'n2'   ,    'nu2'   ,     'm2'    ,   &
-         &         'l2'    ,    't2'    ,     's2'   ,    'k2'    ,     'm4'      /
-      DATA zig/ .2338507481, .2433518789, .2610826055, .2617993878,  .2625161701,   &
-         &      .4868657873, .4881373225, .4963669182, .4976384533,  .5058680490,   &
-         &      .5153691799, .5228820265, .5235987756, .5250323419, 1.011736098   /
-      !!----------------------------------------------------------------------
-!
-!     ihs             -  start time gmt on ...
-!     iday/imnth/iyr  -  date   e.g.   12/10/87
-!
-      CALL vday(iday,imnth,iyr,ivdy)
-      vd = ivdy
-!
-!rp   note change of year number for d. blackman shpen
-!rp   if(iyr.ge.1000) year=iyr-1900
-!rp   if(iyr.lt.1000) year=iyr
-      year = iyr
-!
-!.....year  =  year of required data
-!.....vd    =  day of required data..set up for 0000gmt day year
-      ndc = nc
-!.....ndc   =  number of constituents allowed
-!!gm use rpi ?
-      rtd = 360.0 / 6.2831852
-      DO i = 1, ndc
-         zig(i) = zig(i)*rtd
-         ! sigo(i)= zig(i)
+   END SUBROUTINE bdytide_update
+
+   SUBROUTINE tide_init_elevation( idx, td )
+      !!----------------------------------------------------------------------
+      !!                 ***  ROUTINE tide_init_elevation  ***
+      !!----------------------------------------------------------------------
+      TYPE(OBC_INDEX), INTENT( in )      ::   idx     ! OBC indices
+      TYPE(TIDES_DATA),INTENT( inout )   ::   td      ! tidal harmonics data
+      !! * Local declarations
+      INTEGER, DIMENSION(1)            ::   ilen0       !: length of boundary data (from OBC arrays)
+      REAL(wp),ALLOCATABLE, DIMENSION(:) ::   mod_tide, phi_tide
+      INTEGER                            ::   itide, igrd, ib      ! dummy loop indices
+
+      igrd=1   
+                              ! SSH on tracer grid.
+   
+      ilen0(1) =  SIZE(td%ssh0(:,1,1))
+
+      ALLOCATE(mod_tide(ilen0(igrd)),phi_tide(ilen0(igrd)))
+
+      DO itide = 1, nb_harmo
+         DO ib = 1, ilen0(igrd)
+            mod_tide(ib)=SQRT(td%ssh0(ib,itide,1)**2.+td%ssh0(ib,itide,2)**2.)
+            phi_tide(ib)=ATAN2(-td%ssh0(ib,itide,2),td%ssh0(ib,itide,1))
+         END DO
+         DO ib = 1 , ilen0(igrd)
+            mod_tide(ib)=mod_tide(ib)*ftide(itide)
+            phi_tide(ib)=phi_tide(ib)+v0tide(itide)+utide(itide)
+         ENDDO
+         DO ib = 1 , ilen0(igrd)
+            td%ssh(ib,itide,1)= mod_tide(ib)*COS(phi_tide(ib))
+            td%ssh(ib,itide,2)=-mod_tide(ib)*SIN(phi_tide(ib))
+         ENDDO
       END DO
 
-!!gm try to avoid RETURN  in F90
-      IF( year == 0 )   RETURN
-      
-         CALL shpen( year, vd, ss, h , p , en, p1 )
-         CALL ufset( p   , en, u , f )
-         CALL vset ( ss  , h , p , en, p1, v )
-         !
-         DO k = 1, nc
-            z_vplu(k) = v(k) + u(k)
-            z_vplu(k) = z_vplu(k) + dble(ihs) * zig(k)
-            DO WHILE( z_vplu(k) < 0    )
-               z_vplu(k) = z_vplu(k) + 360.0
-            END DO
-            DO WHILE( z_vplu(k) > 360. )
-               z_vplu(k) = z_vplu(k) - 360.0
-            END DO
-         END DO
-         !
-      END SUBROUTINE uvset
-
-
-      SUBROUTINE vday( iday, imnth, iy, ivdy )
-      !!----------------------------------------------------------------------
-      !!                   *** SUBROUTINE vday  ***
-      !!                  
-      !! ** Purpose : - adjust tidal forcing for date factors
-      !!                
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT(in   ) ::   iday, imnth, iy   ! ????
-      INTEGER, INTENT(  out) ::   ivdy              ! ???
-      !! 
-      INTEGER ::   iyr
-      !!------------------------------------------------------------------------------
-
-!!gm   nday_year in day mode is the variable compiuted here, no?
-!!gm      nday_year ,   &  !: curent day counted from jan 1st of the current year
-
-      !calculate day number in year from day/month/year
-       if(imnth.eq.1) ivdy=iday
-       if(imnth.eq.2) ivdy=iday+31
-       if(imnth.eq.3) ivdy=iday+59
-       if(imnth.eq.4) ivdy=iday+90
-       if(imnth.eq.5) ivdy=iday+120
-       if(imnth.eq.6) ivdy=iday+151
-       if(imnth.eq.7) ivdy=iday+181
-       if(imnth.eq.8) ivdy=iday+212
-       if(imnth.eq.9) ivdy=iday+243
-       if(imnth.eq.10) ivdy=iday+273
-       if(imnth.eq.11) ivdy=iday+304
-       if(imnth.eq.12) ivdy=iday+334
-       iyr=iy
-       if(mod(iyr,4).eq.0.and.imnth.gt.2) ivdy=ivdy+1
-       if(mod(iyr,100).eq.0.and.imnth.gt.2) ivdy=ivdy-1
-       if(mod(iyr,400).eq.0.and.imnth.gt.2) ivdy=ivdy+1
-      !
-   END SUBROUTINE vday
-
-!!doctor norme for dummy arguments
-
-   SUBROUTINE shpen( year, vd, s, h, p, en, p1 )
-      !!----------------------------------------------------------------------
-      !!                    ***  SUBROUTINE shpen  ***
-      !!                   
-      !! ** Purpose : - calculate astronomical arguments for tides
-      !!                this version from d. blackman 30 nove 1990
-      !!
-      !!----------------------------------------------------------------------
-!!gm add INTENT in, out or inout....    DOCTOR name....
-!!gm please do not use variable name with a single letter:  impossible to search in a code
-      INTEGER  ::   year,vd
-      REAL(wp) ::   s,h,p,en,p1
-      !!
-      INTEGER  ::   yr,ilc,icent,it,iday,ild,ipos,nn,iyd
-      REAL(wp) ::   cycle,t,td,delt(84),delta,deltat
-      !!
-      DATA delt /-5.04, -3.90, -2.87, -0.58,  0.71,  1.80,           &
-         &        3.08,  4.63,  5.86,  7.21,  8.58, 10.50, 12.10,    &
-         &       12.49, 14.41, 15.59, 15.81, 17.52, 19.01, 18.39,    &
-         &       19.55, 20.36, 21.01, 21.81, 21.76, 22.35, 22.68,    &
-         &       22.94, 22.93, 22.69, 22.94, 23.20, 23.31, 23.63,    &
-         &       23.47, 23.68, 23.62, 23.53, 23.59, 23.99, 23.80,    &
-         &       24.20, 24.99, 24.97, 25.72, 26.21, 26.37, 26.89,    &
-         &       27.68, 28.13, 28.94, 29.42, 29.66, 30.29, 30.96,    &
-         &       31.09, 31.59, 31.52, 31.92, 32.45, 32.91, 33.39,    &
-         &       33.80, 34.23, 34.73, 35.40, 36.14, 36.99, 37.87,    &
-         &       38.75, 39.70, 40.70, 41.68, 42.82, 43.96, 45.00,    &
-         &       45.98, 47.00, 48.03, 49.10, 50.10, 50.97, 51.81,    &
-         &       52.57 /
-      !!----------------------------------------------------------------------
-
-      cycle = 360.0
-      ilc = 0
-      icent = year / 100
-      yr = year - icent * 100
-      t = icent - 20
-!
-!     for the following equations
-!     time origin is fixed at 00 hr of jan 1st,2000.
-!     see notes by cartwright
-!
-!!gm  old coding style, use CASE instead  and avoid GOTO (obsolescence in fortran 90)
-!!gm obsol(   1): Arithmetic IF statement is used   ===>  remove this in Fortran 90
-      it = icent - 20
-      if (it) 1,2,2
-    1 iday = it/4 -it
-      go to 3
-    2 iday = (it+3)/4 - it
-!
-!     t is in julian century
-!     correction in gegorian calander where only century year divisible
-!     by 4 is leap year.
-!
-    3 continue
-!
-      td = 0.0
-!
-!!gm obsol(   1): Arithmetic IF statement is used   ===>  remove this in Fortran 90
-      if (yr) 4,5,4
-!
-    4 iyd = 365*yr
-      ild = (yr-1)/4
-      if((icent - (icent/4)*4) .eq. 0) ilc = 1
-      td = iyd + ild + ilc
-!
-    5 td = td + iday + vd -1.0 - 0.5
-      t = t + (td/36525.0)
-!
-      ipos=year-1899
-      if (ipos .lt. 0) go to 7
-      if (ipos .gt. 83) go to 6
-!
-      delta = (delt(ipos+1)+delt(ipos))/2.0
-      go to 7
-!
-    6 delta= (65.0-50.5)/20.0*(year-1980)+50.5
-!
-    7 deltat = delta * 1.0e-6
-!
-!!gm   precision of the computation   :  example for s it should be replace by:
-!!gm  s   = 218.3165 + (481267.8813 - 0.0016*t)*t + 152.0*deltat   ==>  more precise  modify the last digits results
-      s   = 218.3165 + 481267.8813*t - 0.0016*t*t + 152.0*deltat
-      h   = 280.4661 + 36000.7698 *t + 0.0003*t*t +  11.0*deltat
-      p   =  83.3535 + 4069.0139  *t - 0.0103*t*t +       deltat
-      en  = 234.9555 + 1934.1363  *t - 0.0021*t*t +       deltat
-      p1  = 282.9384 + 1.7195     *t + 0.0005*t*t
-      !
-      nn = s / cycle
-      s = s - nn * cycle
-      IF( s < 0.e0 )   s = s + cycle
-      !
-      nn = h / cycle
-      h = h - cycle * nn
-      IF( h < 0.e0 )   h = h + cycle
-      !
-      nn = p / cycle
-      p = p - cycle * nn
-      IF( p < 0.e0)   p = p + cycle
-      !
-      nn = en / cycle
-      en = en - cycle * nn
-      IF( en < 0.e0 )   en = en + cycle
-      en = cycle - en
-      !
-      nn = p1 / cycle
-      p1 = p1 - nn * cycle
-      !
-   END SUBROUTINE shpen
-
-
-   SUBROUTINE ufset( p, cn, b, a )
-      !!----------------------------------------------------------------------
-      !!                    ***  SUBROUTINE ufset  ***
-      !!                    
-      !! ** Purpose : - calculate nodal parameters for the tides
-      !!                
-      !!----------------------------------------------------------------------
-!!gm  doctor naming of dummy argument variables!!!   and all local variables
-!!gm  nc is jptides_max ????
-      integer nc
-      parameter (nc=15)
-      REAL(wp) p,cn
-      !!
-      
-!!gm  rad is already a public variable defined in phycst.F90 ....   ==> doctor norme  local real start with "z"
-      REAL(wp) ::   w1, w2, w3, w4, w5, w6, w7, w8, nw, pw, rad
-      REAL(wp) ::   a(nc), b(nc)
-      INTEGER  ::   ndc, k
-      !!----------------------------------------------------------------------
-
-      ndc = nc
-
-!    a=f       ,  b =u
-!    t is  zero as compared to tifa.
-!! use rad defined in phycst   (i.e.  add a USE phycst at the begining of the module
-      rad = 6.2831852d0/360.0
-      pw = p  * rad
-      nw = cn * rad
-      w1 = cos(   nw )
-      w2 = cos( 2*nw )
-      w3 = cos( 3*nw )
-      w4 = sin(   nw )
-      w5 = sin( 2*nw )
-      w6 = sin( 3*nw )
-      w7 = 1. - 0.2505 * COS( 2*pw      ) - 0.1102 * COS(2*pw-nw )   &
-         &    - 0.156  * COS( 2*pw-2*nw ) - 0.037  * COS(     nw )
-      w8 =    - 0.2505 * SIN( 2*pw      ) - 0.1102 * SIN(2*pw-nw )   &
-         &    - 0.0156 * SIN( 2*pw-2*nw ) - 0.037  * SIN(     nw )
-      !
-      a(1) = 1.0089 + 0.1871 * w1 - 0.0147 * w2 + 0.0014 * w3
-      b(1) =          0.1885 * w4 - 0.0234 * w5 + 0.0033 * w6
-      !   q1
-      a(2) = a(1)
-      b(2) = b(1)
-      !   o1
-      a(3) = 1.0
-      b(3) = 0.0
-      !   p1
-      a(4) = 1.0
-      b(4) = 0.0
-      !   s1
-      a(5) = 1.0060+0.1150*w1- 0.0088*w2 +0.0006*w3
-      b(5) = -0.1546*w4 + 0.0119*w5 -0.0012*w6
-      !   k1
-      a(6) =1.0004 -0.0373*w1+ 0.0002*w2
-      b(6) = -0.0374*w4
-      !  2n2
-      a(7) = a(6)
-      b(7) = b(6)
-      !  mu2
-      a(8) = a(6)
-      b(8) = b(6)
-      !   n2
-      a(9) = a(6)
-      b(9) = b(6)
-      !  nu2
-      a(10) = a(6)
-      b(10) = b(6)
-      !   m2
-      a(11) = SQRT( w7 * w7 + w8 * w8 )
-      b(11) = ATAN( w8 / w7 )
-!!gmuse rpi  instead of 3.141992 ???   true pi is rpi=3.141592653589793_wp  .....   ????
-      IF( w7 < 0.e0 )   b(11) = b(11) + 3.141992
-      !   l2
-      a(12) = 1.0
-      b(12) = 0.0
-      !   t2
-      a(13)= a(12)
-      b(13)= b(12)
-      !   s2
-      a(14) = 1.0241+0.2863*w1+0.0083*w2 -0.0015*w3
-      b(14) = -0.3096*w4 + 0.0119*w5 - 0.0007*w6
-      !   k2
-      a(15) = a(6)*a(6)
-      b(15) = 2*b(6)
-      !   m4
-!!gm  old coding,  remove GOTO and label of lines
-!!gm obsol(   1): Arithmetic IF statement is used   ===>  remove this in Fortran 90
-      DO 40 k = 1,ndc
-         b(k) = b(k)/rad
-32       if (b(k)) 34,35,35
-34       b(k) = b(k) + 360.0
-         go to 32
-35       if (b(k)-360.0) 40,37,37
-37       b(k) = b(k)-360.0
-         go to 35
-40    continue
-      !
-   END SUBROUTINE ufset
-   
-
-   SUBROUTINE vset( s,h,p,en,p1,v)
-      !!----------------------------------------------------------------------
-      !!                    ***  SUBROUTINE vset  ***
-      !!                   
-      !! ** Purpose : - calculate tidal phases for 0000gmt on start day of run
-      !!                
-      !!----------------------------------------------------------------------
-!!gm  doctor naming of dummy argument variables!!!   and all local variables
-!!gm  nc is jptides_max ????
-!!gm  en argument is not used: suppress it ?
-      integer nc
-      parameter (nc=15)
-      real(wp) s,h,p,en,p1
-      real(wp)   v(nc)
-      !!
-      integer ndc, k
-      !!----------------------------------------------------------------------
-
-      ndc = nc
-      !   v s  are computed here.
-      v(1) =-3*s +h +p +270      ! Q1
-      v(2) =-2*s +h +270.0       ! O1
-      v(3) =-h +270              ! P1
-      v(4) =180                  ! S1
-      v(5) =h +90.0              ! K1
-      v(6) =-4*s +2*h +2*p       ! 2N2
-      v(7) =-4*(s-h)             ! MU2
-      v(8) =-3*s +2*h +p         ! N2
-      v(9) =-3*s +4*h -p         ! MU2
-      v(10) =-2*s +2*h           ! M2
-      v(11) =-s +2*h -p +180     ! L2 
-      v(12) =-h +p1              ! T2
-      v(13) =0                   ! S2
-      v(14) =h+h                 ! K2
-      v(15) =2*v(10)             ! M4
-!
-!!gm  old coding,  remove GOTO and label of lines
-!!gm obsol(   1): Arithmetic IF statement is used   ===>  remove this in Fortran 90
-      do 72 k = 1, ndc
-69       if( v(k) )   70,71,71
-70       v(k) = v(k)+360.0
-         go to 69
-71       if( v(k) - 360.0 )   72,73,73
-73       v(k) = v(k)-360.0
-         go to 71
-72    continue
-      !
-   END SUBROUTINE vset
-
+      DEALLOCATE(mod_tide,phi_tide)
+
+   END SUBROUTINE tide_init_elevation
+
+   SUBROUTINE tide_init_velocities( idx, td )
+      !!----------------------------------------------------------------------
+      !!                 ***  ROUTINE tide_init_elevation  ***
+      !!----------------------------------------------------------------------
+      TYPE(OBC_INDEX), INTENT( in )      ::   idx     ! OBC indices
+      TYPE(TIDES_DATA),INTENT( inout )      ::   td      ! tidal harmonics data
+      !! * Local declarations
+      INTEGER, DIMENSION(3)            ::   ilen0       !: length of boundary data (from OBC arrays)
+      REAL(wp),ALLOCATABLE, DIMENSION(:) ::   mod_tide, phi_tide
+      INTEGER                            ::   itide, igrd, ib      ! dummy loop indices
+
+      ilen0(2) =  SIZE(td%u0(:,1,1))
+      ilen0(3) =  SIZE(td%v0(:,1,1))
+
+      igrd=2                                 ! U grid.
+
+      ALLOCATE(mod_tide(ilen0(igrd)),phi_tide(ilen0(igrd)))
+
+      DO itide = 1, nb_harmo
+         DO ib = 1, ilen0(igrd)
+            mod_tide(ib)=SQRT(td%u0(ib,itide,1)**2.+td%u0(ib,itide,2)**2.)
+            phi_tide(ib)=ATAN2(-td%u0(ib,itide,2),td%u0(ib,itide,1))
+         END DO
+         DO ib = 1, ilen0(igrd)
+            mod_tide(ib)=mod_tide(ib)*ftide(itide)
+            phi_tide(ib)=phi_tide(ib)+v0tide(itide)+utide(itide)
+         ENDDO
+         DO ib = 1, ilen0(igrd)
+            td%u(ib,itide,1)= mod_tide(ib)*COS(phi_tide(ib))
+            td%u(ib,itide,2)=-mod_tide(ib)*SIN(phi_tide(ib))
+         ENDDO
+      END DO
+
+      DEALLOCATE(mod_tide,phi_tide)
+
+      igrd=3                                 ! V grid.
+
+      ALLOCATE(mod_tide(ilen0(igrd)),phi_tide(ilen0(igrd)))
+
+      DO itide = 1, nb_harmo
+         DO ib = 1, ilen0(igrd)
+            mod_tide(ib)=SQRT(td%v0(ib,itide,1)**2.+td%v0(ib,itide,2)**2.)
+            phi_tide(ib)=ATAN2(-td%v0(ib,itide,2),td%v0(ib,itide,1))
+         END DO
+         DO ib = 1, ilen0(igrd)
+            mod_tide(ib)=mod_tide(ib)*ftide(itide)
+            phi_tide(ib)=phi_tide(ib)+v0tide(itide)+utide(itide)
+         ENDDO
+         DO ib = 1, ilen0(igrd)
+            td%v(ib,itide,1)= mod_tide(ib)*COS(phi_tide(ib))
+            td%v(ib,itide,2)=-mod_tide(ib)*SIN(phi_tide(ib))
+         ENDDO
+      END DO
+
+      DEALLOCATE(mod_tide,phi_tide)
+
+  END SUBROUTINE tide_init_velocities
 #else
    !!----------------------------------------------------------------------
    !!   Dummy module         NO Unstruct Open Boundary Conditions for tides
    !!----------------------------------------------------------------------
-!!gm  are you sure we need to define filtide and tide_cpt ?
-   CHARACTER(len=80), PUBLIC               ::   filtide                !: Filename root for tidal input files
-   CHARACTER(len=4 ), PUBLIC, DIMENSION(1) ::   tide_cpt               !: Names of tidal components used.
-
 CONTAINS
-   SUBROUTINE tide_init                ! Empty routine
-   END SUBROUTINE tide_init
-   SUBROUTINE tide_data                ! Empty routine
-   END SUBROUTINE tide_data
-   SUBROUTINE tide_update( kt, kit )   ! Empty routine
-      WRITE(*,*) 'tide_update: You should not have seen this print! error?', kt, kit
-   END SUBROUTINE tide_update
+   SUBROUTINE bdytide_init             ! Empty routine
+      WRITE(*,*) 'bdytide_init: You should not have seen this print! error?'
+   END SUBROUTINE bdytide_init
+   SUBROUTINE bdytide_update( kt, jit )   ! Empty routine
+      WRITE(*,*) 'bdytide_update: You should not have seen this print! error?', kt, jit
+   END SUBROUTINE bdytide_update
 #endif
 
Index: /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90
===================================================================
--- /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 3582)
+++ /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 3583)
@@ -23,8 +23,10 @@
    USE in_out_manager  ! I/O manager
 
+
    IMPLICIT NONE
    PRIVATE
 
    PUBLIC bdy_tra      ! routine called in tranxt.F90 
+   PUBLIC bdy_tra_dmp  ! routine called in step.F90 
 
    !!----------------------------------------------------------------------
@@ -53,8 +55,18 @@
          CASE(jp_frs)
             CALL bdy_tra_frs( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
+         CASE(2)
+            CALL bdy_tra_spe( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
+         CASE(3)
+            CALL bdy_tra_nmn( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
+         CASE(4)
+            CALL bdy_tra_rnf( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
          CASE DEFAULT
             CALL ctl_stop( 'bdy_tra : unrecognised option for open boundaries for T and S' )
          END SELECT
       ENDDO
+      !
+      ! Boundary points should be updated
+      IF (nb_bdy>0) CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )
+      IF (nb_bdy>0) CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )
 
    END SUBROUTINE bdy_tra
@@ -90,6 +102,4 @@
       END DO 
       !
-      CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )   ; CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )    ! Boundary points should be updated
-      !
       IF( kt .eq. nit000 ) CLOSE( unit = 102 )
       !
@@ -97,5 +107,170 @@
       !
    END SUBROUTINE bdy_tra_frs
-   
+  
+   SUBROUTINE bdy_tra_spe( idx, dta, kt )
+      !!----------------------------------------------------------------------
+      !!                 ***  SUBROUTINE bdy_tra_frs  ***
+      !!                    
+      !! ** Purpose : Apply a specified value for tracers at open boundaries.
+      !! 
+      !!----------------------------------------------------------------------
+      INTEGER,         INTENT(in) ::   kt
+      TYPE(OBC_INDEX), INTENT(in) ::   idx  ! OBC indices
+      TYPE(OBC_DATA),  INTENT(in) ::   dta  ! OBC external data
+      !! 
+      REAL(wp) ::   zwgt           ! boundary weight
+      INTEGER  ::   ib, ik, igrd   ! dummy loop indices
+      INTEGER  ::   ii, ij         ! 2D addresses
+      !!----------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 ) CALL timing_start('bdy_tra_spe')
+      !
+      igrd = 1                       ! Everything is at T-points here
+      DO ib = 1, idx%nblenrim(igrd)
+         ii = idx%nbi(ib,igrd)
+         ij = idx%nbj(ib,igrd)
+         DO ik = 1, jpkm1
+            tsa(ii,ij,ik,jp_tem) = dta%tem(ib,ik) * tmask(ii,ij,ik)
+            tsa(ii,ij,ik,jp_sal) = dta%sal(ib,ik) * tmask(ii,ij,ik)
+         END DO
+      END DO
+      !
+      IF( kt .eq. nit000 ) CLOSE( unit = 102 )
+      !
+      IF( nn_timing == 1 ) CALL timing_stop('bdy_tra_spe')
+      !
+   END SUBROUTINE bdy_tra_spe
+
+   SUBROUTINE bdy_tra_nmn( idx, dta, kt )
+      !!----------------------------------------------------------------------
+      !!                 ***  SUBROUTINE bdy_tra_nmn  ***
+      !!                    
+      !! ** Purpose : Duplicate the value for tracers at open boundaries.
+      !! 
+      !!----------------------------------------------------------------------
+      INTEGER,         INTENT(in) ::   kt
+      TYPE(OBC_INDEX), INTENT(in) ::   idx  ! OBC indices
+      TYPE(OBC_DATA),  INTENT(in) ::   dta  ! OBC external data
+      !! 
+      REAL(wp) ::   zwgt           ! boundary weight
+      INTEGER  ::   ib, ik, igrd   ! dummy loop indices
+      INTEGER  ::   ii, ij,zcoef, zcoef1,zcoef2, ip, jp   ! 2D addresses
+      !!----------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 ) CALL timing_start('bdy_tra_nmn')
+      !
+      igrd = 1                       ! Everything is at T-points here
+      DO ib = 1, idx%nblenrim(igrd)
+         ii = idx%nbi(ib,igrd)
+         ij = idx%nbj(ib,igrd)
+         DO ik = 1, jpkm1
+            ! search the sense of the gradient
+            zcoef1 = bdytmask(ii-1,ij  ) +  bdytmask(ii+1,ij  )
+            zcoef2 = bdytmask(ii  ,ij-1) +  bdytmask(ii  ,ij+1)
+            IF ( zcoef1+zcoef2 == 0) THEN
+               ! corner
+               zcoef = tmask(ii-1,ij,ik) + tmask(ii+1,ij,ik) +  tmask(ii,ij-1,ik) +  tmask(ii,ij+1,ik)
+               tsa(ii,ij,ik,jp_tem) = tsa(ii-1,ij  ,ik,jp_tem) * tmask(ii-1,ij  ,ik) + &
+                 &                    tsa(ii+1,ij  ,ik,jp_tem) * tmask(ii+1,ij  ,ik) + &
+                 &                    tsa(ii  ,ij-1,ik,jp_tem) * tmask(ii  ,ij-1,ik) + &
+                 &                    tsa(ii  ,ij+1,ik,jp_tem) * tmask(ii  ,ij+1,ik)
+               tsa(ii,ij,ik,jp_tem) = ( tsa(ii,ij,ik,jp_tem) / MAX( 1, zcoef) ) * tmask(ii,ij,ik)
+               tsa(ii,ij,ik,jp_sal) = tsa(ii-1,ij  ,ik,jp_sal) * tmask(ii-1,ij  ,ik) + &
+                 &                    tsa(ii+1,ij  ,ik,jp_sal) * tmask(ii+1,ij  ,ik) + &
+                 &                    tsa(ii  ,ij-1,ik,jp_sal) * tmask(ii  ,ij-1,ik) + &
+                 &                    tsa(ii  ,ij+1,ik,jp_sal) * tmask(ii  ,ij+1,ik)
+               tsa(ii,ij,ik,jp_sal) = ( tsa(ii,ij,ik,jp_sal) / MAX( 1, zcoef) ) * tmask(ii,ij,ik)
+            ELSE
+               ip = bdytmask(ii+1,ij  ) - bdytmask(ii-1,ij  )
+               jp = bdytmask(ii  ,ij+1) - bdytmask(ii  ,ij-1)
+               tsa(ii,ij,ik,jp_tem) = tsa(ii+ip,ij+jp,ik,jp_tem) * tmask(ii+ip,ij+jp,ik)
+               tsa(ii,ij,ik,jp_sal) = tsa(ii+ip,ij+jp,ik,jp_sal) * tmask(ii+ip,ij+jp,ik)
+            ENDIF
+         END DO
+      END DO
+      !
+      IF( kt .eq. nit000 ) CLOSE( unit = 102 )
+      !
+      IF( nn_timing == 1 ) CALL timing_stop('bdy_tra_nmn')
+      !
+   END SUBROUTINE bdy_tra_nmn
+
+   SUBROUTINE bdy_tra_rnf( idx, dta, kt )
+      !!----------------------------------------------------------------------
+      !!                 ***  SUBROUTINE bdy_tra_rnf  ***
+      !!                    
+      !! ** Purpose : Apply the runoff values for tracers at open boundaries:
+      !!                  - specified to 0.1 PSU for the salinity
+      !!                  - duplicate the value for the temperature
+      !! 
+      !!----------------------------------------------------------------------
+      INTEGER,         INTENT(in) ::   kt
+      TYPE(OBC_INDEX), INTENT(in) ::   idx  ! OBC indices
+      TYPE(OBC_DATA),  INTENT(in) ::   dta  ! OBC external data
+      !! 
+      REAL(wp) ::   zwgt           ! boundary weight
+      INTEGER  ::   ib, ik, igrd   ! dummy loop indices
+      INTEGER  ::   ii, ij, ip, jp ! 2D addresses
+      !!----------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 ) CALL timing_start('bdy_tra_rnf')
+      !
+      igrd = 1                       ! Everything is at T-points here
+      DO ib = 1, idx%nblenrim(igrd)
+         ii = idx%nbi(ib,igrd)
+         ij = idx%nbj(ib,igrd)
+         DO ik = 1, jpkm1
+            ip = bdytmask(ii+1,ij  ) - bdytmask(ii-1,ij  )
+            jp = bdytmask(ii  ,ij+1) - bdytmask(ii  ,ij-1)
+            tsa(ii,ij,ik,jp_tem) = tsa(ii+ip,ij+jp,ik,jp_tem) * tmask(ii,ij,ik)
+            tsa(ii,ij,ik,jp_sal) =                        0.1 * tmask(ii,ij,ik)
+         END DO
+      END DO
+      !
+      IF( kt .eq. nit000 ) CLOSE( unit = 102 )
+      !
+      IF( nn_timing == 1 ) CALL timing_stop('bdy_tra_rnf')
+      !
+   END SUBROUTINE bdy_tra_rnf
+
+   SUBROUTINE bdy_tra_dmp( kt )
+      !!----------------------------------------------------------------------
+      !!                 ***  SUBROUTINE bdy_tra_dmp  ***
+      !!                    
+      !! ** Purpose : Apply damping for tracers at open boundaries.
+      !! 
+      !!----------------------------------------------------------------------
+      INTEGER,         INTENT(in) ::   kt
+      !! 
+      REAL(wp) ::   zwgt           ! boundary weight
+      REAL(wp) ::   zta, zsa, ztime
+      INTEGER  ::   ib, ik, igrd   ! dummy loop indices
+      INTEGER  ::   ii, ij         ! 2D addresses
+      INTEGER  ::   ib_bdy         ! Loop index
+      !!----------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 ) CALL timing_start('bdy_tra_dmp')
+      !
+      DO ib_bdy=1, nb_bdy
+         IF ( ln_tra_dmp(ib_bdy) ) THEN
+            igrd = 1                       ! Everything is at T-points here
+            DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
+               ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+               ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+               zwgt = idx_bdy(ib_bdy)%nbd(ib,igrd)
+               DO ik = 1, jpkm1
+                  zta = zwgt * ( dta_bdy(ib_bdy)%tem(ib,ik) - tsb(ii,ij,ik,jp_tem) ) * tmask(ii,ij,ik)
+                  zsa = zwgt * ( dta_bdy(ib_bdy)%sal(ib,ik) - tsb(ii,ij,ik,jp_sal) ) * tmask(ii,ij,ik)
+                  tsa(ii,ij,ik,jp_tem) = tsa(ii,ij,ik,jp_tem) + zta
+                  tsa(ii,ij,ik,jp_sal) = tsa(ii,ij,ik,jp_sal) + zsa
+               END DO
+            END DO
+         ENDIF
+      ENDDO
+      !
+      IF( nn_timing == 1 ) CALL timing_stop('bdy_tra_dmp')
+      !
+   END SUBROUTINE bdy_tra_dmp
+ 
 #else
    !!----------------------------------------------------------------------
